#include "parameters.h"
#include "sampler.h"

namespace
{
    typedef struct collector_t
    {
        uint_least16_t index;
        short min;
        short max;
        int8_t *samples;
    } collector_t;
    collector_t volatile sample_struct = {};
}

ISR(ADC_vect)
{
    int8_t val = ADCH - 128;
    if (val < sample_struct.min)
        sample_struct.min = val;
    if (val > sample_struct.max)
        sample_struct.max = val;
    if (sample_struct.index < no_samples){
        sample_struct.samples[sample_struct.index] = val;
        sample_struct.index++;
    }
    else
        ADCSRA = prescaler | B10000000;
}

void begin()
{
    sample_struct.samples = new int8_t[no_samples];
    sample();
}

void sample()
{
    sample_struct.index = 0;
    sample_struct.min = 127;
    sample_struct.max = -128;
    ADCSRB = B01000000;
    ADMUX = B00100000;
    ADCSRA = prescaler | B11101000;
}

int8_t *return_samples()
{
    while (ADCSRA & B00001000){}

    bool out_of_bounds = (sample_struct.max == -128) || (sample_struct.max == 127);
    uint_least8_t amp = (int16_t)sample_struct.max - sample_struct.min;

    if (amp > 60 && !out_of_bounds)
        return sample_struct.samples;
    else
        return nullptr;
}

